/*
 * Copyright (c) 2012-2017. Sencha Inc.
 */

var Fashion = require('../../index.js');
var assert = require('assert');
var helpers = require('../helpers.js');


describe("api", function(){
    
    describe("map", function(){
        helpers.test('should support map function', [
            '$var: (foo: bar, baz: bing);',
            '$var2: (one: two, three: four);',
            '$var3: map-merge($var, $var2);',
            '$var4: map-merge($var3, (five: six));',
            'map-remove($var4, "baz");',
            'blat {',
            '    a: map-get($var3, "foo");',
            '    a: map-get($var3, "baz");',
            '    a: map-get($var3, "one");',
            '    a: map-get($var3, "three");',
            '    b: map-keys($var3);',
            '    b: map-values($var3);',
            '    c: map-has-key($var3, foo);',
            '    c: map-has-key($var3, bar);',
            '    d: map-keys($var4);',
            '    d: map-values($var4);',
            '}',
        ], [
            'blat {',
            '    a: bar;',
            '    a: bing;',
            '    a: two;',
            '    a: four;',
            '    b: foo, baz, one, three;',
            '    b: bar, bing, two, four;',
            '    c: true;',
            '    c: false;',
            '    d: foo, one, three, five;',
            '    d: bar, two, four, six;',
            '}'
        ]);
        
    });
});